• HDU 4632 Palindrome subsequence (区间DP)


    Palindrome subsequence

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65535 K (Java/Others)
    Total Submission(s): 558    Accepted Submission(s): 203


    Problem Description
    In mathematics, a subsequence is a sequence that can be derived from another sequence by deleting some elements without changing the order of the remaining elements. For example, the sequence <A, B, D> is a subsequence of <A, B, C, D, E, F>.
    (http://en.wikipedia.org/wiki/Subsequence)

    Given a string S, your task is to find out how many different subsequence of S is palindrome. Note that for any two subsequence X = <Sx1, Sx2, ..., Sxk> and Y = <Sy1, Sy2, ..., Syk> , if there exist an integer i (1<=i<=k) such that xi != yi, the subsequence X and Y should be consider different even if Sxi = Syi. Also two subsequences with different length should be considered different.
     
    Input
    The first line contains only one integer T (T<=50), which is the number of test cases. Each test case contains a string S, the length of S is not greater than 1000 and only contains lowercase letters.
     
    Output
    For each test case, output the case number first, then output the number of different subsequence of the given string, the answer should be module 10007.
     
    Sample Input
    4 a aaaaa goodafternooneveryone welcometoooxxourproblems
     
    Sample Output
    Case 1: 1 Case 2: 31 Case 3: 421 Case 4: 960
     
    Source
     
    Recommend
    zhuyuanchen520
     

     第一次接触,

    题意:

    一个字符串,有多少个subsequence是回文串。

    题解:

    用dp[i][j]表示这一段里有多少个回文串,那首先dp[i][j]=dp[i+1][j]+dp[i][j-1],但是dp[i+1][j]和dp[i][j-1]可能有公共部分,所以要减去dp[i+1][j-1]。

    如果str[i]==str[j]的话,还要加上dp[i+1][j-1]+1。

    #include<iostream>
    #include<cstdio>
    #include<cstring>
    
    using namespace std;
    
    const int N=1010;
    const int mod=10007;
    
    char str[N];
    int dp[N][N];
    
    int main(){
    
        //freopen("input.txt","r",stdin);
    
        int t,cases=0;
        scanf("%d",&t);
        while(t--){
            scanf("%s",str);
            int len=strlen(str);
            memset(dp,0,sizeof(dp));
            for(int i=0;i<len;i++)
                dp[i][i]=1;
            for(int i=0;i<len;i++)
                for(int j=i-1;j>=0;j--){
                    dp[j][i]=(dp[j][i-1]+dp[j+1][i]-dp[j+1][i-1]+mod)%mod;
                    if(str[i]==str[j])
                        dp[j][i]=(dp[j][i]+dp[j+1][i-1]+1+mod)%mod;
                }
            printf("Case %d: %d
    ",++cases,dp[0][len-1]);
        }
        return 0;
    }
    #include<iostream>
    #include<cstdio>
    #include<cstring>
    
    using namespace std;
    
    const int N=1010;
    const int mod=10007;
    
    char str[N];
    int dp[N][N];
    
    int DFS(int l,int r){
        if(l>r)
            return 0;
        if(l==r)
            return 1;
        if(dp[l][r]!=-1)
            return dp[l][r];
        dp[l][r]=(DFS(l+1,r)+DFS(l,r-1)-DFS(l+1,r-1)+mod)%mod;
        if(str[l]==str[r])
            dp[l][r]=(dp[l][r]+DFS(l+1,r-1)+1+mod)%mod;
        return dp[l][r];
    }
    
    int main(){
    
        //freopen("input.txt","r",stdin);
    
        int t,cases=0;
        scanf("%d",&t);
        while(t--){
            scanf("%s",str+1);
            int len=strlen(str+1);
            memset(dp,-1,sizeof(dp));
            printf("Case %d: %d
    ",++cases,DFS(1,len));
        }
        return 0;
    }
  • 相关阅读:
    hdu1852 Beijing 2008
    hdu-2582 f(n)---找规律+素数筛法
    hdu-1452 Happy 2004---因子和+逆元
    LightOJ-1028 Trailing Zeroes (I)---因子数目
    hdu1215 七夕节---因子和
    因子和&&因子数
    hdu-1492 The number of divisors(约数) about Humble Numbers---因子数公式
    hdu-2136 Largest prime factor---巧用素数筛法
    欧拉函数
    BZOJ4418: [Shoi2013]扇形面积并
  • 原文地址:https://www.cnblogs.com/jackge/p/3231535.html
Copyright © 2020-2023  润新知